#include <common.h>
#include <asm/arch/matrix500.h>


#ifdef CFG_MATRIX500
void matrix500_gpio_init(void){
	
	AT91C_BASE_PIOD->PIO_PER=1<<(MATRIX500_DEBUG_LED1-96)|1<<(MATRIX500_DEBUG_LED2-96)|1<<(MATRIX500_DEBUG_LED3-96)|1<<(MATRIX500_DEBUG_LED4-96)| 1<<(MATRIX500_READY_LED-96);

	AT91C_BASE_PIOD->PIO_OER =1<<(MATRIX500_DEBUG_LED1-96)|1<<(MATRIX500_DEBUG_LED2-96)|1<<(MATRIX500_DEBUG_LED3-96)| 1<<(MATRIX500_DEBUG_LED4-96)|1<<(MATRIX500_READY_LED-96);
	AT91C_BASE_PIOD->PIO_SODR = 1<<(MATRIX500_READY_LED-96); //Ready LED
	//AT91C_BASE_PIOD->PIO_CODR = 1<<(MATRIX500_DEBUG_LED3-96); //LED3:ON
	AT91C_BASE_PIOB->PIO_PER = 1<<(MATRIX500_BUZZER-32);
	AT91C_BASE_PIOB->PIO_OER = 1<<(MATRIX500_BUZZER-32);
	AT91C_BASE_PIOC->PIO_PDR = (1<<7) | (1<<8); //A23, A24

#ifdef 	CFG_FLASH_32M
	AT91C_BASE_PIOD->PIO_PER = AT91C_PIO_PD4;
	AT91C_BASE_PIOD->PIO_OER = AT91C_PIO_PD4;
	AT91C_BASE_PIOD->PIO_CODR = AT91C_PIO_PD4;
#endif
	/* Power OFF all USART's LEDs */
	AT91C_BASE_PIOA->PIO_PER =  AT91C_PA5_TXD3|AT91C_PA6_RXD3|AT91C_PA17_TXD0|AT91C_PA18_RXD0|AT91C_PA22_RXD2|   AT91C_PA23_TXD2;
	AT91C_BASE_PIOA->PIO_OER =  AT91C_PA5_TXD3|AT91C_PA6_RXD3|AT91C_PA17_TXD0|AT91C_PA18_RXD0|AT91C_PA22_RXD2|    AT91C_PA23_TXD2;
	AT91C_BASE_PIOA->PIO_SODR = AT91C_PA5_TXD3|AT91C_PA6_RXD3|AT91C_PA17_TXD0|AT91C_PA18_RXD0|AT91C_PA22_RXD2|    AT91C_PA23_TXD2;
	AT91C_BASE_PIOB->PIO_PER = AT91C_PB20_RXD1|AT91C_PB21_TXD1;
	AT91C_BASE_PIOB->PIO_OER = AT91C_PB20_RXD1|AT91C_PB21_TXD1;
	AT91C_BASE_PIOB->PIO_SODR = AT91C_PB20_RXD1|AT91C_PB21_TXD1;
	
	/* set gpio to Input */
	AT91C_BASE_PIOB->PIO_PER =  AT91_PIO_PA19;
	AT91C_BASE_PIOB->PIO_ODR =  AT91_PIO_PA19;
	AT91C_BASE_PIOB->PIO_PPUDR= AT91_PIO_PA19;
	
	AT91C_BASE_PIOB->PIO_PER =  AT91_PIO_PB22|AT91C_PIO_PB16|AT91C_PIO_PB2|AT91C_PIO_PB8|AT91C_PIO_PB9|AT91C_PIO_PB10|AT91C_PIO_PB11|AT91C_PIO_PB29|AT91C_PIO_PB28;
	AT91C_BASE_PIOB->PIO_ODR =  AT91_PIO_PB22|AT91C_PIO_PB16|AT91C_PIO_PB2|AT91C_PIO_PB8|AT91C_PIO_PB9|AT91C_PIO_PB10|AT91C_PIO_PB11|AT91C_PIO_PB29|AT91C_PIO_PB28;
	AT91C_BASE_PIOB->PIO_PPUDR= AT91_PIO_PB22|AT91C_PIO_PB16|AT91C_PIO_PB2|AT91C_PIO_PB8|AT91C_PIO_PB9|AT91C_PIO_PB10|AT91C_PIO_PB11|AT91C_PIO_PB29|AT91C_PIO_PB28;
	
	AT91C_BASE_PIOD->PIO_PER =  AT91C_PIO_PD25|AT91_PIO_PD24|AT91_PIO_PD7|AT91_PIO_PD8|AT91_PIO_PD9|AT91_PIO_PD10|AT91_PIO_PD11|AT91_PIO_PD12;
	AT91C_BASE_PIOD->PIO_OER =  AT91C_PIO_PD25|AT91_PIO_PD24|AT91_PIO_PD7|AT91_PIO_PD8|AT91_PIO_PD9|AT91_PIO_PD10|AT91_PIO_PD11|AT91_PIO_PD12;
	AT91C_BASE_PIOD->PIO_PPUDR= AT91C_PIO_PD25|AT91_PIO_PD24|AT91_PIO_PD7|AT91_PIO_PD8|AT91_PIO_PD9|AT91_PIO_PD10|AT91_PIO_PD11|AT91_PIO_PD12; 
	
	AT91C_BASE_PIOC->PIO_PER =  AT91C_PIO_PC0|AT91C_PIO_PC1|AT91C_PIO_PC2|AT91C_PIO_PC3|AT91C_PIO_PC5|AT91_PIO_PC14|AT91_PIO_PC15;
	AT91C_BASE_PIOC->PIO_ODR =  AT91C_PIO_PC0|AT91C_PIO_PC1|AT91C_PIO_PC2|AT91C_PIO_PC3|AT91C_PIO_PC5|AT91_PIO_PC14|AT91_PIO_PC15;
	AT91C_BASE_PIOC->PIO_PPUDR =  AT91C_PIO_PC0|AT91C_PIO_PC1|AT91C_PIO_PC2|AT91C_PIO_PC3|AT91C_PIO_PC5|AT91_PIO_PC14|AT91_PIO_PC15;

}

uchar matrix500_gpio_set(MATRIX500_PIO io){
	uchar status = 0xff;
	switch(io){
		case MATRIX500_DEBUG_LED1:
		case MATRIX500_DEBUG_LED2:
		case MATRIX500_DEBUG_LED3:
		case MATRIX500_DEBUG_LED4:
		case MATRIX500_READY_LED:
			AT91C_BASE_PIOD->PIO_SODR = 1<<(io-96);
			status = AT91C_BASE_PIOD->PIO_ODSR & (1<<(io-96));
		break;
		case MATRIX500_BUZZER:
			AT91C_BASE_PIOB->PIO_SODR = 1<<(io-32);
			status = AT91C_BASE_PIOB->PIO_ODSR & (1<<(io-32));
		break;		
	}
	return status;
}	
uchar matrix500_gpio_clear(MATRIX500_PIO io){
	uchar status = 0xff;
	switch(io){
		case MATRIX500_DEBUG_LED1:
		case MATRIX500_DEBUG_LED2:
		case MATRIX500_DEBUG_LED3:
		case MATRIX500_DEBUG_LED4:
		case MATRIX500_READY_LED:
			AT91C_BASE_PIOD->PIO_CODR = 1<<(io-96);
			status = AT91C_BASE_PIOD->PIO_ODSR & (1<<(io-96));
		break;
		case MATRIX500_BUZZER:
			AT91C_BASE_PIOB->PIO_CODR = 1<<(io-32);
			status = AT91C_BASE_PIOB->PIO_ODSR & (1<<(io-32));
		break;		
	}
	return status;
}	
#endif
